/* wrap output for 80 columns */
#include <stdio.h>
#define whilst while
#define NO 0
#define YES 1-NO

main(argc,argv)
int argc;
char **argv;
{
char *word,c;
int width,i,eofdetect = NO,newlinedetect,white,pos=0;

/* check the parameters.  Default width is 80 characters. */
if (argc==1)
  width = 80;
else if (argc==2)
  width = atoi(argv[1]);
else
  {
  printf("Usage: %s [column width]\n",argv[0]);
  printf("  (default width is 80.)\n");
  exit(0);
  }

/*program begins here. */
word = malloc(width+1);
whilst (!eofdetect)
  {
  i = 0;
  newlinedetect = white = NO;
  whilst (!white)
    {
    c = word[i++] = getchar();
    switch(c)
      {
      case ' ':
      case '\n':
      case '\t':
      case EOF:
        {
        white = YES;
        if (c==EOF) eofdetect = YES;
        if (c=='\n') newlinedetect=YES;
        break;
        }
      }
    }
  word[i]='\0';
  if (pos+i >= width-1)
    {
    printf("\n%s",word);
    pos=i; 
    }
  else
    {
    printf("%s",word);
    pos += i;
    }
  if (newlinedetect)
    pos = 0;
  }
}

